﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
/*Add this line to use PowerPointWriter:*/
using SoftArtisans.OfficeWriter.PowerPointWriter;

namespace HelloWorld.PowerPointWriter
{
    public partial class PowerPointTemplate_HelloWorld : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ErrorLabel.Visible = false;
        }

        protected void RunHelloWorld_Click(object sender, EventArgs e)
        {
            try
            {
                //Instantiate the PowerPointTemplate object
                PowerPointTemplate PPTT = new PowerPointTemplate();

                //Open the template file
                PPTT.Open(Page.MapPath(@"templates\Hello World.pptx"));

                /*DataBindingProperties can be used to determine how the data 
                 * is imported. We're not going to use the properties in this 
                 * example, but it's required for binding data to the template*/
                DataBindingProperties DataProps = PPTT.CreateDataBindingProperties();

                //Get the data
                string value = DataValueBox.Text.Trim();

                /*Create an object array that contains the values for the data markers */
                string[] values = { value };

                /*Create a string array containing column names */
                string[] colNames = { "DataValue" };

                /*Set the data source and give it a name*/
                PPTT.BindData(values, colNames, "DataSource1", DataProps);

                //Process handles inserting the data into the file
                PPTT.Process();

                /*One of the output options is to stream directly to the user 
                 * as an attachment. The'False' parameter means it should be 
                 * sent as an attachment, rather than inline*/
                PPTT.Save(Page.Response, "Output.pptx", false);

            }
            catch (Exception ex)
            {
                ErrorLabel.Visible = true;
                if (ex.Message.Contains("General license key exception"))
                {
                    ErrorLabel.Text = "OfficeWriter does not appear to be" +
                       " installed on this machine. If you have not " +
                       "purchased OfficeWriter, you can download the " +
                       "evaluation version here: " +
                       "http://www.officewriter.com/officewriter-free-evaluation.aspx";
                }
                else
                {
                    ErrorLabel.Text = ex.Message;
                }

            }

        }
    }
}
